#!/usr/local/bin/perl

################################################################
# File: getRankings.pl                                         #
# Description: This script queries SEs                         #
#              to produce rankings report                      #
# BE CAREFUL WITH THIS SCRIPT OR ITS MODIFICATIONS!!           # 
# AS YOUR IP MAY BE BLOCKED TEMPORARILY                        # 
################################################################

### Basic setup part
$numOfArgs = $#ARGV + 1;
$originalkeywordphrase = "";
$targeturl="";

if ( ($numOfArgs == 0) || ($numOfArgs == 1) || ($numOfArgs < 0)) {
   print ("\n\nUsage: perl getRanking.pl [TargetURL] [Keyword]\n");
   print ("\nOR\n");
   print ("\nUsage: perl getRanking.pl [TargetURL] [Keyword1] [Keyword2] ... [KeywordN]\n\n");
   exit(0);
} 

$targeturl=$ARGV[0];

if ( $numOfArgs == 2){
   $originalkeywordphrase = $ARGV[1];
}else {
   foreach $argnum (1 .. $#ARGV) {
      $originalkeywordphrase =  $originalkeywordphrase . " " . $ARGV[$argnum]; 

      #remove leading & trailing spaces 
      $originalkeywordphrase =~ s/^\s+//; 
      $originalkeywordphrase =~ s/\s+$//;  
   }
}
  
$keywordphrase= $originalkeywordphrase;
$keywordphrase =~ s/([^A-Za-z0-9])/sprintf("%%%02X", ord($1))/seg;

# define Source Urls
$listingNo=100;

$gurl= "http://www.google.com/search?num=$listingNo&hl=en&safe=off&q=$keywordphrase&sa=N";
$burl= "http://www.bing.com/search?q=$keywordphrase&first=1&count=100&";

### get SERP pages part
# get google SERP
$gserp = `wget "$gurl" --user-agent="Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.0)"  
--output-document="gserp.html" --cookies=off`;
# get Bing SERP
$bserp = `wget "$burl" --user-agent="Mozilla/4.0 (compatible; MSIE 7.0; Windows NT 6.0)"  
--output-document="bserp.html" --cookies=off`;

### analysis part
$googlePositionNumber = getPosition ($targeturl, "google"); 
$bingSearchPositionNumber = getPosition ($targeturl, "bing"); 

# report part
##########################
print "\nRanking Summary Report\n";
print   "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n";
print   "Keyword/Phrase: $originalkeywordphrase\n";
print   "Target URL: $targeturl\n";
print   "~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~\n";
print   " Google.....: $googlePositionNumber\n";

if($bingSearchPositionNumber ne "not found"){
   $cntAdjusted = $bingSearchPositionNumber + 1;
   print   " Bing Search: $cntAdjusted\n";
}else{
   print   " Bing Search: $bingSearchPositionNumber\n";
}   
print "\nNote: Check with specific SE to ensure correctness.\n";

##### SUBROUTINES ####################################
sub getContent {
   $filename=shift;
   open INPUT, "<$filename";
   undef $/;
   $content = <INPUT>;
   close INPUT;
   #Restore behaviour
   $/ = "\n"; 

   #substitute new line character with space character
   $content =~ s/\n/ /g;
   #substitute quotes with nothing 
   $content =~ s/\"//g;

   #cleanup bing
   $content =~ s/<strong>//g;
   $content =~ s/<\/strong>//g;

   $content =~ s/<cite>//g;
   $content =~ s/<\/cite>//g;

   return $content;    
}

sub getPosition {
   $targeturl= shift; 
   $se = shift;
   @tokens = ();
   $offset = 0;
   if($se eq "google") {
      $gcontent = getContent("gserp.html");
      @tokens = split(/h3 class=r/, $gcontent);
   } elsif($se eq "bing") { 
      $bcontent = getContent("bserp.html");
      @tokens = split(/sa_cc/, $bcontent);
      $offset=2;
   }

   $mastercnt = "not found";
   $cnt=0;
   $foundFlag = "no";
   print "number of tokens:". $#tokens;
   foreach $token (@tokens) {
      #print "\ntoken: $token";
      if ($token =~ /$targeturl/gi) {
         if($foundFlag eq "no") {
            $mastercnt = $cnt - $offset;
         } else {
            $mastercnt = "" . $mastercnt . "," . $cnt;
         }
         #print "\nMATCH: $targeturl cnt: $cnt $mastercnt\n token";

         #got a match return back position number
         $foundFlag = "yes";
      }
      $cnt = $cnt + 1; 
   }   
   return $mastercnt;
}