#!/usr/local/bin/perl
###########################################################
# File: inlinksAnalysis.pl                                #
# Description: This script performs analysis on Yahoo!    # 
#              inbound links TSD file                     #
###########################################################

use LWP::Simple;
use LWP::UserAgent;
use HTML::TokeParser;

my @URLs = ();

#get the input param name of the file
my $fileToProcess = $ARGV[0]; 
my $baseurl = $ARGV[1]; 

print "\nProcessing: $fileToProcess"; 

my $cnt = 0;
# open the file
if (-e "$fileToProcess"){ 
   open FILE, "$fileToProcess" or die $!;
   while (<FILE>) { 
      my $line = $_; 
      my @fragments = split(/\t/, $line);   
      my $url = $fragments[1];
      #print "\n$url";
      $URLs[$cnt] = $url;
      $cnt++; 
   }
} else {
    print "\nfile ($fileToProcess) does not exist";      
}

my $ua = new LWP::UserAgent;
my $res;
$ua->agent("My Crawler");
my %linkPopHash = ();
my %anchorPopHash = ();

for(my $i=0; $i<=$cnt; $i++) {
   $res = $ua->get("$URLs[$i]",':content_file' => "temp.txt");
   if (-e "temp.txt") { 
      my $p = HTML::TokeParser->new("temp.txt");
      while (my $token = $p->get_tag("a")) {
         #get link and anchor text
         my $url = $token->[1]{href} || "-";
         my $anchorText = $p->get_trimmed_text("/a");

         $url =~ s/^\s+//g;
         $url =~ s/\s+$//g;

         my $text = $p->get_trimmed_text("/a");
         if ($url =~ /$baseurl/i) {
            #print "\n$baseurl URL: $URLs[$i] LINK: $url";
            if(exists $linkPopHash{$url}){
               $linkPopHash{$url} = $linkPopHash{$url} + 1;
               $anchorPopHash{$url} = $anchorText;
            } else {
               $linkPopHash{$url} = 1;
               $anchorPopHash{$url} = $anchorText;
            }         
         }
      }
   }
}

open (FP, '>report.txt');
foreach my $key ( sort { $linkPopHash{$b} <=> $linkPopHash{$a} } keys %linkPopHash ) {
        print FP "$key, $linkPopHash{$key}, \"$anchorPopHash{$key}\"\n";
} 
close (FP); 

