#!/usr/local/bin/perl
###########################################
# File: linkchecker.pl                    #
# Description: Check Broken Links Script  #
#                                         # 
###########################################

use WWW::Mechanize;
use LWP::Simple;

my $baseurl = shift;
my @url=(); 
my @level=();
my @type=();
my @title=();
my @status=();
my @page=();
my %uniqueURL=();
my %checkedURL=();
my $masterCnt=0;
my $masterLevel=1;

$mech  = WWW::Mechanize->new();
#### Processing Level One
$mech->get( $baseurl );
@links = $mech->links();
foreach $link (@links) {
  $tmpurl = $baseurl . '/' . $link->url();         
  if ( ($link->url() !~ /mailto/i) &&
       ($link->url() !~ /javascript/i ) ) {
    if ($link->url() !~ /^http/) {  
      #collect unique URL       
      $uniqueURL{$tmpurl}=$link->text();
      $url[$masterCnt]=$tmpurl;
      $type[$masterCnt]= "relative";
    }else {
      $tmpurl = $link->url();
      $uniqueURL{$link->url()}=$link->text();
      $url[$masterCnt]=$link->url();
      if( $link->url() =~ /$baseurl/ ){
        $type[$masterCnt]= "absolute internal";
      }else {
        $type[$masterCnt]= "outbound";
      }     
    }      
    $level[$masterCnt]=$masterLevel;  
    $title[$masterCnt]=$link->text();
    $page[$masterCnt]=$baseurl;
    $masterCnt++;
  }
}
$masterLevel++;
$linksOnFirstLevel=$masterCnt;

####Processing Level Two 
%levTwoURLs = ();
$masterCnt = processSubLevel(2, 
                       $masterCnt,
                            \@url, 
                          \@level, 
                           \@type, 
                          \@title, 
                         \@status, 
                           \@page, 
                      \%uniqueURL,
                         $baseurl, 
                     $masterLevel,
                      \%levTwoURLs);

$masterLevel++;
$linksOnSecondLevel = keys(%levTwoURLs);

####Processing Level Three 
%levThreeURLs = ();
$masterCnt = processSubLevel(3, 
                       $masterCnt,
                            \@url, 
                          \@level, 
                           \@type, 
                          \@title, 
                         \@status, 
                           \@page, 
                    \%levTwoURLs,
                         $baseurl, 
                     $masterLevel,
                    \%levThreeURLs);
$masterLevel++;
$linksOnThirdLevel = keys(%levThreeURLs);

####Processing Level Four
%levFourURLs = ();
$masterCnt = processSubLevel(4, 
                       $masterCnt,
                            \@url, 
                          \@level, 
                           \@type, 
                          \@title, 
                         \@status, 
                           \@page, 
                   \%levThreeURLs,
                         $baseurl, 
                     $masterLevel,
                     \%levFourURLs);
$linksOnFourthLevel = keys(%levFourURLs);
printReport(\@level,\@page,\@url,\@type,\@title,\@status, $masterCnt);

#### subroutines
sub processSubLevel {
  my ($currentLevel,
             $mstCnt,
             $urlArr,
              $leArr,
              $tyArr,
              $tiArr,
              $stArr,
              $paArr,
               $urls,
               $burl,
             $mlevel,
             $uniqueHashRef) = @_;
  
  my %urlHash = (); 
  foreach $item (@$urlArr){
    $urlHash{$item} = 1;
  }

  foreach $lURL (keys %$urls) {
    if( ($lURL !~ /.gif$/) &&
        ($lURL !~ /.jpg$/) &&
        ($lURL !~ /.png$/) &&
        ($lURL !~ /.pdf$/) &&
        ($lURL !~ /.doc$/) &&
        ($lURL !~ /.xls$/) &&
        ($lURL !~ /.asf$/) &&
        ($lURL !~ /.mov$/) &&
        ($lURL !~ /.avi$/) &&
        ($lURL !~ /.xvid$/) &&
        ($lURL !~ /.flv$/) &&
        ($lURL !~ /.mpg$/) &&
        ($lURL !~ /.3gp$/) &&
        ($lURL !~ /.mp4$/) &&
        ($lURL !~ /.qt$/) &&
        ($lURL !~ /.rm$/) &&
        ($lURL !~ /.swf$/) &&
        ($lURL !~ /.wmv$/) &&
        ($lURL !~ /.txt$/) &&
        ($lURL !~ /.js$/) &&
        ($lURL !~ /.css$/) &&
        ($lURL =~ /$burl/) &&
        ($lURL !~ /mailto/i)&&
        ($lURL !~ /javascript/i)  ) {
      $mech->get( $lURL );
      @sublinks = $mech->links();
      $cnt2=0;
      foreach $link (@sublinks) {
        my $tmpurl ="";
        #assuming relative link creating temp variable
        if ( $link->url() !~ /^http/i ) {
          $tmpurl = $burl . '/' . $link->url();
        }else {
          $tmpurl = $link->url();
        }

        if(!(exists $urlHash{$tmpurl}) ){ 
          if ( ($link->url() !~ /mailto/i) &&
              ($link->url() !~ /javascript/i ) ) {
             #check UNIQUENESS
             if( !(exists $urls->{$tmpurl}) ) {
                $urls->{$tmpurl}=$link->text();
                $uniqueHashRef->{ $tmpurl } = $link->text();
             }
             # check if link relative or absolute
             if ( $link->url() !~ /^http/ ) {
               ## RELATIVE
               $urlArr->[$mstCnt]= $tmpurl;
               $tyArr->[$mstCnt]= "relative internal";
             }else {
               ## ABSOLUTE
               #adjusting temp variable
               $urlArr->[$mstCnt]=$link->url();
               if( $link->url() =~ /$baseurl/ ){
                 $tyArr->[$mstCnt]= "absolute internal";
               }else {
                 $tyArr->[$mstCnt]= "outbound";
               }
             }
             $leArr->[$mstCnt]=$mlevel;
             $tiArr->[$mstCnt]=$link->text();
             $paArr->[$mstCnt]=$tmpurl;
             $mstCnt++;
          }  
        }
      }
    }
  }
  return ($mstCnt);
}

sub printReport {
  my ($levelArr, 
        $pageArr, 
        $urlArr, 
       $typeArr, 
      $titleArr, 
     $statusArr,
          $mCnt) = @_;
  %tmpCleanupHash=();
  print "Level\tParent Page or Location\tUnique URL\tLink Type\tTitle\tStatus Codes";
  for($i=0;$i<$mCnt;$i++) {
    if ( !(exists $tmpCleanupHash{$url[$i]}) ){  
      $tmpCleanupHash{$url[$i]} = 1;
      if ($levelArr->[$i] ne "") {
        print "\n$levelArr->[$i]\t$pageArr->[$i]\t$urlArr->[$i]\t$typeArr->[$i]\t$titleArr->[$i]\t".getstore($urlArr->[$i], "temp");
      }
    }  
  }
}
