################################################
# File: mymonitor.pl                           #
# Description: This script takes an argument   #
#              reporesenting a web page url    #
# Format: perl mymonitor.pl http://www.xyz.com #
################################################
use threads;
use Benchmark;
use Time::HiRes qw(gettimeofday tv_interval);
use LWP::Simple;
use LWP::UserAgent;
use File::Path;

#get page to monitor
my $pageToMonitor = shift;
my $ua = new LWP::UserAgent;
my $res;

#cleanup temp files
rmtree( './temp', {keep_root => 1} );

# start timer
my $start_time = [ gettimeofday ];
$res = $ua->get("$pageToMonitor",':content_file' => "./temp/temp.dat");
# stop timer
my $end_time = [ gettimeofday ];

print tv_interval($start_time,$end_time) , "\n";
my $elapsedtime = tv_interval($start_time,$end_time);

##### CREATING DATA FILES ################################################
my ($sec,$min,$hour,$mday,$mon,$year,$wday,$yday,$isdst) = localtime time;
$year += 1900;
$mon++;

# Create today.txt
open OUTPTR, ">>./report/today/today.txt";
print OUTPTR "$mday-$mon-$year $hour:$min:$sec;10;15;20;$elapsedtime\n";
close OUTPTR;

# Create month.txt
open OUTPTR, ">>./report/month/month.txt";
print OUTPTR "$mday-$mon-$year $hour:$min:$sec;10;15;20;$elapsedtime\n";
close OUTPTR;

# Create year.txt
open OUTPTR, ">>./report/year/year.txt";
print OUTPTR "$mday-$mon-$year $hour:$min:$sec;10;15;20;$elapsedtime\n";
close OUTPTR;

# Create historical.txt
open OUTPTR, ">>./report/historical/historical.txt";
print OUTPTR "$mday-$mon-$year $hour:$min:$sec;10;15;20;$elapsedtime\n";
close OUTPTR;


